; (c) 1992 Dirk Schwarzhans, Matthias Braun
; Use under the terms of the GNU General Public License */
   
; IIC-Bus-Routinen

; Das folgende Macro wartet 5 us
WAITLONG	macro
		   .LOOP	#54		; im Gegensatz zu rep ist eine
			nop				; do-Schleife unterbrechbar
		   .ENDL			; (fr sptere Erweiterungen)
			endm

; Die folgenden beiden Macros mssen zusammen auch mindestens
; fnf Mikrosekunden verzgern; die Verteilung der Verzgerung
; zwischen beiden bestimmt den Abtastzeitpunkt beim Lesen
WAITSHORT1	macro
		   .LOOP	#26
			nop
		   .ENDL
			endm
			
WAITSHORT2	macro
		   .LOOP	#26
			nop
		   .ENDL
			endm

; startet eine IIC-Bus-Sequenz
startiic
  bset	#SDA_OUT,x:m_pcd	; SDA = low
  WAITLONG
  bclr	#SCL_OUT,x:m_pcd	; SCL = low
  rts

; IIC-Bus-Sequenz beenden
stopiic
  bset	#SDA_OUT,x:m_pcd	; SDA = low
  WAITLONG
  bset	#SCL_OUT,x:m_pcd	; SCL = high
  WAITLONG
  bclr	#SDA_OUT,x:m_pcd	; SDA = high
  WAITLONG
  rts

; die folgende Routine sendet das Byte in a1 und schiebt dabei
; Akkumulator a 8 Bits nach links; c = Quittierungsbit 
; (0, wenn weitergemacht werden soll, sonst 1)
sendbyte
 .LOOP	#8					; 8 Bits senden
  jset	#7,a1,send1			; Bit abfragen
  bset	#SDA_OUT,x:m_pcd	; 0 senden
  jmp	_sent0
send1
  bclr	#SDA_OUT,x:m_pcd	; 1 senden
_sent0
  WAITLONG
  bset	#SCL_OUT,x:m_pcd	; SCL = high
  WAITLONG
  bclr	#SCL_OUT,x:m_pcd	; SCL = low
  asl	a					; nchstes Bit bearbeiten
 .ENDL
  bclr	#SDA_OUT,x:m_pcd	; SDA = high
  WAITLONG
  bset	#SCL_OUT,x:m_pcd	; SCL = high
  WAITSHORT1
  move	x:m_pcd,a1			; Quittierungsbit lesen
  WAITSHORT2
  bclr	#SCL_OUT,x:m_pcd	; SCL = low
  btst	#SDA_IN,a1			; Quittierungsbit ins Carry kopieren
  rts

; liest ein Byte nach a1 und quittiert mit weitermachen
receive
  jsr	getdata				; liest die eigentlichen Daten
  bset	#SDA_OUT,x:m_pcd	; SDA = low (Quittierung)
  WAITLONG
  bset	#SCL_OUT,x:m_pcd	; SCL = high
  WAITLONG
  bclr	#SCL_OUT,x:m_pcd	; SCL = low
  bclr	#SDA_OUT,x:m_pcd	; SDA = high
  rts

; liest ein Byte nach a1 und quittiert mit aufhoeren
receivelast
  jsr		getdata			; liest die eigentlichen Daten
  WAITLONG
  bset	#SCL_OUT,x:m_pcd	; SCL = high
  WAITLONG
  bclr	#SCL_OUT,x:m_pcd	; SCL = low
  rts

; liest die eigentlichen Daten ein; die eingelesenen Daten
; befinden sich in a1, Bits 7 bis 0
getdata
  clr	a
 .LOOP	#8
  WAITLONG
  bset	#SCL_OUT,x:m_pcd	; SCL = high
  WAITSHORT1
  asl	a					; Daten eine Position weiterschieben
  jclr	#SDA_IN,x:m_pcd,_got0
  bset	#0,a1				; Bit entsprechend setzen
_got0
  WAITSHORT2
  bclr	#SCL_OUT,x:m_pcd	; SCL = low
 .ENDL
  rts

  if *>$200
	warn 'Interner Programmspeicherberlauf'
  endif

