/* (c) 1992 Dirk Schwarzhans, Matthias Braun
   Use under the terms of the GNU General Public License */
   
#import <objc/Object.h>

#import <appkit/color.h>

#import <appkit/Box.h>
#import <appkit/Matrix.h>
#import <appkit/NXColorWell.h>
#import <appkit/PopUpList.h>
#import "VideoTextView.h"

@interface Inspector:Object
{
    id	inspectorMenuButton;
	id	menuCell1;
	id	menuCell2;
	id	menuCell3;
    id	requestDataForm;
    id	displayControlBox;
    id	colorControlBox;
	id	ivtControlBox;
    id	colorWellGreen;
    id	colorWellBlue;
    id	colorWellBlack;
    id	colorWellWhite;
    id	colorWellYellow;
    id	colorWellCyan;
    id	colorWellMagenta;
    id	colorWellRed;
	id	showHiddenSwitch;
	id	flashSwitch;
    id	inspectorPanel;
    id	pageDataBox;
    id	fontSizeForm;
    id	subpageSwitch;
    id	idleBox;
	id	holdSwitch;
	id	subpageButtons;
	id	pageRequestButton;
	id	incomingPagesText;
	id	teleDisplaySwitches;
	id	normpageInBoxSwitches;
	id	normpageOutBoxSwitches;
	id	newspageInBoxSwitches;
	id	newspageOutBoxSwitches;
	id	boxPositionSwitches;

	Box				*activeBox;
	Matrix			*menuMatrix;
	BOOL			enabled;
	VideoTextView	*inspectedView;
	NXColorWell		*colorWells[VT_COLORS];
	id				delegate;
}

- init;
- initAndEnable:(BOOL)mode;
- makeKeyAndOrderFront:sender;
- setEnabled:(BOOL)mode;
- (BOOL)isEnabled;
- inspectView:(VideoTextView *)view;
- setDelegate:object;

- setIncomingPage:(const char *)number;
- setHoldPageSwitch:(BOOL)mode;
- setCareSubpage:(BOOL)mode;
- setRequestPage:(int)page;
- setRequestSubpage:(int)subpage;

// Methoden, die durch appkit-Objekte aufgerufen werden
- resetColorPanel:sender;
- setColors:sender;
- displaySwitchChanged:sender;
- newPageRequested:sender;
- subpageSwitchChanged:sender;
- menuEntrySelected:sender;
- holdSwitchChanged:sender;
- subpageForwardBackward:sender;
- clearPageMemory:sender;
- newPageNumberEntered:sender;
- textDidEnd:sender endChar:(unsigned short)whyEnd;
- ivtSwitchesChanged:sender;

@end
