/* (c) 1992 Dirk Schwarzhans, Matthias Braun
   Use under the terms of the GNU General Public License */
   
#import <objc/Object.h>

#import <appkit/MenuCell.h>
#import <appkit/SavePanel.h>
#import <appkit/View.h>
#import <appkit/Window.h>
#import "Inspector.h"
#import <objc/HashTable.h>
#import "PageSupplier.h"
#import "WindowContainer.h"
#import "VideoTextView.h"
#import "VTListener.h"

@interface MainController:Object
{
	id	menuSave;
	id	menuSaveAs;
	id	menuSaveEPS;
	id	menuClose;
	id	menuCut;
	id	menuCopy;
	id	menuPaste;
	id	menuCopyEPS;
	id	menuSelectAll;
	id	menuPrint;
	id	timePanel;
	id	timeText;

	Inspector		*inspector;
	PageSupplier	*pageSupplier;
	HashTable		*windowList;
	WindowContainer	*activeContainer;
	SavePanel		*savePanel;
	VTListener		*listener;
	unsigned		tag;
}

- init;
- free;

- windowServices:(BOOL)mode;
- (Window *)createNewWindow;

- inspectorRequested:sender;
- openNewWindow:sender;
- createEPSFile:sender;
- copyAsEPS:sender;
- print:sender;
- openTimePanel:sender;

// Methoden als 'delegate' von VideoTextView
- requestPage:(int)page subpage:(int)subpage forWindow:(Window *)window;

// Methoden als 'delegate' von Inspector
- clearPageMemoryRequested;
- subpageBrowse:(int)direction;
- holdPage:(BOOL)mode;
- setIVTRegisters:(unsigned char)mode :(unsigned char)normDispCtrl 
  :(unsigned char)newsDispCtrl :(unsigned char)dispMode;

// Methoden als 'delegate' von Listener
-(int)updateClock:(char *)time size:(int)bytes return:(int *)dummy;
-(int)updateRollingHeader:(char *)pageNumber size:(int)bytes return:(int *)dummy;
-(int)updatePageData:(char *)pageInfo size:(int)bytes return:(int *)dummy;
-(int)printError : (char *) message;

// Methoden als 'delegate' von Window
- windowWillClose:sender;
- windowDidBecomeMain:sender;

// Methoden als 'delegate' von Application
- appDidInit:sender;

@end
